config/routes.rb
Rails.application.routes.draw do

  
  devise_for :users
  get 'overview' => 'categories#index'
  get 'manage' => 'pages#manage'
  
  resources :categories do
    resources :transactions
  end
  
  resources :incomes
  resources :transactions 

  root 'pages#index'

  

end

app/controllers/transactions_controller.rb
# coding: utf-8
class TransactionsController < ApplicationController
  before_action :set_transaction, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!
  
  # GET /transactions
  # GET /transactions.json
  def index
    transactions_getter(params)

    # this is for displaying the transaction form on the main page
    @transaction = current_user.transactions.new
    @categories = current_user.categories.all
    @title = "Log a cost for a category"
  end

  # GET /transactions/1
  # GET /transactions/1.json
  def show
  end

  # GET /transactions/new
  def new
    @title = "Log a cost for a category"
    @transaction = current_user.transactions.new
    @categories = current_user.categories.all
  end

  # GET /transactions/1/edit
  def edit
    @categories = current_user.categories.all
  end

  # POST /transactions
  # POST /transactions.json
  def create
    @categories = current_user.categories.all

    if category?(params)
      @transaction = current_user.categories.find(params[:category_id]).transactions.new(transaction_params)
    else
      @transaction = current_user.transactions.new(transaction_params)
    end

    respond_to do |format|
      if @transaction.save
        format.html { redirect_to @transaction, notice: 'Transaction was successfully created.' }
        format.json { render :show, status: :created, location: @transaction }
      else
        format.html { render :new }
        format.json { render json: @transaction.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /transactions/1
  # PATCH/PUT /transactions/1.json
  def update
    respond_to do |format|
      if @transaction.update(transaction_params)
        format.html { redirect_to @transaction, notice: 'Transaction was successfully updated.' }
        format.json { render :show, status: :ok, location: @transaction }
      else
        format.html { render :edit }
        format.json { render json: @transaction.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /transactions/1
  # DELETE /transactions/1.json
  def destroy
    @transaction.destroy
    respond_to do |format|
      format.html { redirect_to transactions_url, notice: 'Transaction was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
  # Use callbacks to share common setup or constraints between actions.
  def set_transaction
    @transaction = Transaction.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def transaction_params
    params.require(:transaction).permit(:name, :category_id, :amount)
  end
end

app/helpers/transactions_helper.rb
module TransactionsHelper
end

app/views/transactions/_form.html.erb
<div class="col-md-6 col-md-offset-3">
  <%= form_for([@category, @transaction], :html => {:class => "form"}) do |f| %>

    <% if @transaction.errors.any? %>
      <div id="error_explanation">
        <h2><%= pluralize(@transaction.errors.count, "error") %> prohibited this transaction from being saved:</h2>

        <ul>
          <% @transaction.errors.full_messages.each do |message| %>
            <li><%= message %></li>
          <% end %>
        </ul>
      </div>
    <% end %>

    <% if !@categories.nil? %>
      <div class="form-group">
        <label for=""></label>
        <%= f.collection_select :category_id, @categories, :id, :name, {}, {:class => "form-control"} %>
      </div>
    <% end %>
    
    <div class="form-group">
      <%= f.label :name, :class => "sr-only"%>
      <%= f.text_field :name, :class => "form-control", :placeholder => "Dog food"%>
    </div>


    
    <div class="form-group">
      <%= f.label :amount, :class => "sr-only "%>
      <div class="input-group">
        <div class="input-group-addon">$</div>
        <%= f.text_field :amount, :class => "form-control", :placeholder => "1.99", :size=>5 %>
      </div>
    </div>

    
    <%= f.submit "Add", :class => "btn btn-default" %>
    <%= link_to "Delete", transaction_path(@transaction), method: :delete, data: { confirm: 'Are you sure?' }, :class => "btn btn-danger pull-right" %>        
  <% end %>

</div>

app/views/transactions/_form_all.html.erb
<div class="col-md-6 col-md-offset-3">

  <%= form_for(@transaction, :html => {:class => "form"}) do |f| %>

    <% if @transaction.errors.any? %>
      <div id="error_explanation">
        <h2><%= pluralize(@transaction.errors.count, "error") %> prohibited this transaction from being saved:</h2>

        <ul>
          <% @transaction.errors.full_messages.each do |message| %>
            <li><%= message %></li>
          <% end %>
        </ul>
      </div>
    <% end %>


    <div class="form-group">
      <%= f.label :category %> 
      <%= f.collection_select :category_id, @categories, :id, :name, {}, {:class => "form-control"} %>
    </div>

    
    
    <div class="form-group">
      <%= f.label :name, :class => "sr-only"%>
      <%= f.text_field :name, :class => "form-control", :placeholder => "Dog food"%>
    </div>


    
    <div class="form-group">
      <%= f.label :amount, :class => "sr-only "%>
      <div class="input-group">
        <div class="input-group-addon">$</div>
        <%= f.text_field :amount, :class => "form-control", :placeholder => "1.99", :size=>5 %>
      </div>
    </div>

    
    <%= f.submit "Add", :class => "btn btn-default" %>


  <% end %>
  
</div>

app/views/transactions/edit.html.erb
<%= render 'form_all' %>
<div class="row">
  <%= link_to "Delete", transactions_path(@transaction), method: :delete, data: { confirm: 'Are you sure?' }, :class => "btn btn-danger pull-right" %>
</div>

app/views/transactions/index.html.erb
<!-- <div class="progress">
     <div class="progress-bar progress-bar-info" role="progressbar" aria-valuenow="20" aria-valuemin="0" aria-valuemax="100" style="width: 20%">
     <span class="sr-only">20% Complete</span>
     </div>
     </div>
   -->
<div class="row">
  <!-- <div class="col-xs-6"><%#%>= submit_tag 'Log a purchase', :type => 'button', :id => "spend-money", :class => "btn btn-default" %></div>; -->

  <!-- <div id="spend-form"> -->
    <%= render partial: "transactions/form_all", locals: { transaction: @transaction } %>  
  <!-- </div> -->
</div>

<div style="margin-top: 25px;"class="row">
  <p class="text-center"><button class="btn button-default" id="show-trans">Show last 10 transactions</button></p>
</div>

<div id="transactions-all" class="table-responsive">
  <table class="table table-hover">
    <caption>Transactions</caption>
    <thead>
    </thead>
    <tbody id="trans">
      <% @transactions.each do |trans| %>
        <tr>
          <td><%= link_to trans.name, edit_category_transaction_path(trans.category, trans) %></td>
          <td><em><small><%= number_to_currency(trans.amount, :precision => 2)  %></small></em></td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>  

app/views/transactions/new.html.erb
<%= render 'form_all' %>

app/views/transactions/show.html.erb
<p>
  <strong>Name:</strong>
  <%= @transaction.name %>
</p>

<p>
  <strong>Category:</strong>
  <%= @transaction.category.name %>
</p>

<p>
  <strong>Amount:</strong>
  <%= @transaction.amount %>
</p>